## org.apache.poi.poifs.filesystem
Class DocumentInputStream

    java.lang.Object
      java.io.InputStream
          org.apache.poi.poifs.filesystem.DocumentInputStream

public class DocumentInputStream
extends java.io.InputStream

This class provides methods to read a DocumentEntry managed by a Filesystem instance.

Author:
  Marc Johnson (mjohnson at apache dot org)

Constructor Summary
`DocumentInputStream(DocumentEntry document)` Create an InputStream from the specified DocumentEntry
`DocumentInputStream(POIFSDocument document)` Create an InputStream from the specified Document

Method Summary
`int` `available()` Returns the number of bytes that can be read (or skipped over) from this input stream without blocking by the next caller of a method for this input stream.
`void` `close()` Closes this input stream and releases any system resources associated with the stream.
`void` `mark(int ignoredReadlimit)` Marks the current position in this input stream.
`boolean` `markSupported()` Tests if this input stream supports the mark and reset methods.
`int` `read()` Reads the next byte of data from the input stream.
`int` `read(byte[] b)` Reads some number of bytes from the input stream and stores them into the buffer array b.
`int` `read(byte[] b, int off, int len)` Reads up to len bytes of data from the input stream into an array of bytes.
`void` `reset()` Repositions this stream to the position at the time the mark method was last called on this input stream.
`long` `skip(long n)` Skips over and discards n bytes of data from this input stream.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DocumentInputStream

    public DocumentInputStream(DocumentEntry document)
                        throws java.io.IOException

  Create an InputStream from the specified DocumentEntry

Parameters:
  `document` - the DocumentEntry to be read
Throws:
  `java.io.IOException` - if the DocumentEntry cannot be opened (like, maybe it has been deleted?)

### DocumentInputStream

    public DocumentInputStream(POIFSDocument document)
                        throws java.io.IOException

  Create an InputStream from the specified Document

Parameters:
  `document` - the Document to be read
Throws:
  `java.io.IOException` - if the DocumentEntry cannot be opened (like, maybe it has been deleted?)

Method Detail

### available

    public int available()
                  throws java.io.IOException

  Returns the number of bytes that can be read (or skipped over) from this input stream without blocking by the next caller of a method for this input stream. The next caller might be the same thread or or another thread.

  Returns:
    the number of bytes that can be read from this input stream without blocking.
  Throws:
    `java.io.IOException` - on error (such as the stream has been closed)

### close

    public void close()
               throws java.io.IOException

  Closes this input stream and releases any system resources associated with the stream.

  Throws:
    `java.io.IOException`

### mark

    public void mark(int ignoredReadlimit)

  Marks the current position in this input stream. A subsequent call to the reset method repositions this stream at the last marked position so that subsequent reads re-read the same bytes.

  The readlimit arguments tells this input stream to allow that many bytes to be read before the mark position gets invalidated. This implementation, however, does not care.

  The general contract of mark is that, if the method markSupported returns true, the stream somehow remembers all the bytes read after the call to mark and stands ready to supply those same bytes again if and whenever the method reset is called. However, the stream is not required to remember any data at all if more than readlimit bytes are read from the stream before reset is called. But this stream will.

  Parameters:
    `ignoredReadlimit` - the maximum limit of bytes that can be read before the mark position becomes invalid. Ignored by this implementation.

### markSupported

    public boolean markSupported()

  Tests if this input stream supports the mark and reset methods.

  Returns:
    true

### read

    public int read()
             throws java.io.IOException

  Reads the next byte of data from the input stream. The value byte is returned as an int in the range 0 to 255. If no byte is available because the end of the stream has been reached, the value -1 is returned. The definition of this method in java.io.InputStream allows this method to block, but it won't.

  Returns:
    the next byte of data, or -1 if the end of the stream is reached.
  Throws:
    `java.io.IOException`

### read

    public int read(byte[] b)
             throws java.io.IOException,
                    java.lang.NullPointerException

  Reads some number of bytes from the input stream and stores them into the buffer array b. The number of bytes actually read is returned as an integer. The definition of this method in java.io.InputStream allows this method to block, but it won't.

  If b is null, a NullPointerException is thrown. If the length of b is zero, then no bytes are read and 0 is returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at end of file, the value -1 is returned; otherwise, at least one byte is read and stored into b.

  The first byte read is stored into element b[0], the next one into b[1], and so on. The number of bytes read is, at most, equal to the length of b. Let k be the number of bytes actually read; these bytes will be stored in elements b[0] through b[k-1], leaving elements b[k] through b[b.length-1] unaffected.

  If the first byte cannot be read for any reason other than end of file, then an IOException is thrown. In particular, an IOException is thrown if the input stream has been closed.

  The read(b) method for class InputStream has the same effect as:

  `read(b, 0, b.length)`

  Parameters:
    `b` - the buffer into which the data is read.
  Returns:
    the total number of bytes read into the buffer, or -1 if there is no more data because the end of the stream has been reached.
  Throws:
    `java.io.IOException`
    `java.lang.NullPointerException`

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws java.io.IOException,
                    java.lang.NullPointerException,
                    java.lang.IndexOutOfBoundsException

  Reads up to len bytes of data from the input stream into an array of bytes. An attempt is made to read as many as len bytes, but a smaller number may be read, possibly zero. The number of bytes actually read is returned as an integer.

  The definition of this method in java.io.InputStream allows it to block, but it won't.

  If b is null, a NullPointerException is thrown.

  If off is negative, or len is negative, or off+len is greater than the length of the array b, then an IndexOutOfBoundsException is thrown.

  If len is zero, then no bytes are read and 0 is returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at end of file, the value -1 is returned; otherwise, at least one byte is read and stored into b.

  The first byte read is stored into element b[off], the next one into b[off+1], and so on. The number of bytes read is, at most, equal to len. Let k be the number of bytes actually read; these bytes will be stored in elements b[off] through b[off+k-1], leaving elements b[off+k] through b[off+len-1] unaffected.

  In every case, elements b[0] through b[off] and elements b[off+len] through b[b.length-1] are unaffected.

  If the first byte cannot be read for any reason other than end of file, then an IOException is thrown. In particular, an IOException is thrown if the input stream has been closed.

  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset in array b at which the data is written.
    `len` - the maximum number of bytes to read.
  Returns:
    the total number of bytes read into the buffer, or -1 if there is no more data because the end of the stream has been reached.
  Throws:
    `java.io.IOException`
    `java.lang.NullPointerException`
    `java.lang.IndexOutOfBoundsException`

### reset

    public void reset()

  Repositions this stream to the position at the time the mark method was last called on this input stream.

  The general contract of reset is:

  - If the method markSupported returns true, then:
    - If the method mark has not been called since the stream was created, or the number of bytes read from the stream since mark was last called is larger than the argument to mark at that last call, then an IOException might be thrown.
    - If such an IOException is not thrown, then the stream is reset to a state such that all the bytes read since the most recent call to mark (or since the start of the file, if mark has not been called) will be resupplied to subsequent callers of the read method, followed by any bytes that otherwise would have been the next input data as of the time of the call to reset.
  - If the method markSupported returns false, then:
    - The call to reset may throw an IOException.
    - If an IOException is not thrown, then the stream is reset to a fixed state that depends on the particular type of the input and how it was created. The bytes that will be supplied to subsequent callers of the read method depend on the particular type of the input stream.

  All well and good ... this class's markSupported method returns true and this method does not care whether you've called mark at all, or whether you've exceeded the number of bytes specified in the last call to mark. We're basically walking a byte array ... mark and reset to your heart's content.

### skip

    public long skip(long n)
              throws java.io.IOException

  Skips over and discards n bytes of data from this input stream. The skip method may, for a variety of reasons, end up skipping over some smaller number of bytes, possibly 0. This may result from any of a number of conditions; reaching end of file before n bytes have been skipped is only one possibility. The actual number of bytes skipped is returned. If n is negative, no bytes are skipped.

  Parameters:
    `n` - the number of bytes to be skipped.
  Returns:
    the actual number of bytes skipped.
  Throws:
    `java.io.IOException`

Copyright © 2003 Apache Software Foundation.